<template>
  <div>
    <a-modal v-model:visible="isVisible" :title="statusActive" @cancel="closeModal">
      <a-form :model="modelRef" v-bind="formItemLayout">
        <a-form-item label="Tên đăng nhập" v-bind="validateInfos.name">
          <a-input v-model:value="modelRef.name" :disabled="props.modalMode !== mode.CREATE" />
        </a-form-item>
        <a-form-item name="date" label="Ngày sinh">
          <a-date-picker :disabled="props.modalMode === mode.VIEW" v-model:value="modelRef['date']"
            value-format="YYYY/MM/DD" :format="dateFormatList" />
        </a-form-item>
        <a-form-item label="Password" name="password">
          <a-input-password v-model:value="modelRef.password" :disabled="props.modalMode !== mode.EDIT" />
        </a-form-item>
        <a-form-item v-if="modelRef._id" label="Trạng thái">
          <a-select :disabled="props.modalMode === mode.VIEW" v-model:value="modelRef.isActive">
            <a-select-option value="true">Hoạt động</a-select-option>
            <a-select-option value="false">Không hoạt động</a-select-option>
          </a-select>
        </a-form-item>
      </a-form>
      <template #footer>
        <a-button v-if="!statusModal" @click="handleSubmit()" type="primary" :loading="modelRef.isLoading">
          {{ modelRef._id ? 'Cập nhật ' : 'Thêm tài khoản' }}
        </a-button>
        <a-button @click="closeModal" :loading="modelRef.isLoading">Hủy</a-button>
      </template>
    </a-modal>
  </div>
</template>
  
<script setup>
import { Form, message } from 'ant-design-vue';
import { watch, reactive, computed } from "vue";
import { bool, func, string, object, oneOf } from "vue-types";

import { dateFormatList, mode } from "@/utils/constants";
import { useLoading } from "@/utils/hooks";

import { formItemLayout } from "./data";

const props = defineProps({
  isVisible: bool(),
  modalMode: oneOf([mode.CREATE, mode.EDIT, mode.VIEW]),
  onHideModal: func(),
  onEditAccount: object(),
  onExcute: func(),
  statusActive: string()
});

const useForm = Form.useForm;
const modelRef = reactive({
  name: "",
  _id: "",
  date: "",
  isActive: "",
  password: "",
  isLoading: false
});

const rulesRef = reactive({
  name: [{
    required: true,
    message: 'Please input name!',
  }],
});
const { resetFields, validate, validateInfos } = useForm(modelRef, rulesRef);
const handleSubmit = async () => {
  validate().then(() => {
    props.onExcute(modelRef)
  })
    .catch(err => {
      message.error("Xin hay điền đúng các trường")
    });
};

const statusModal = computed(() => {
  if (props.statusActive === mode.VIEW) return true
})
const closeModal = () => {
  props.onHideModal()
  resetFields()
}

watch(() => props.onEditAccount, (data) => {
  modelRef.name = data.name,
    modelRef.date = data.date,
    modelRef.isActive = String(data.isActive)
  modelRef.password = data.password
  modelRef._id = data._id
}
)
</script>